function gc = dIdc(img, win)

[rows, cols] = size(img);

if nargin < 2
    win = [-1 0 1; -1 0 1; -1 0 1] / 3;
elseif any(mod(size(win), 2) == 0)
    error('Window dimensions must be odd')
end

s = floor(size(win) / 2);
hr = s(1);
hc = s(2);

gc = zeros(size(img));
for r = (1+hr):(rows-hr)
    for c = (1+hc):(cols-hc)
        p = win .* img(r + [(-hr):hr], c + [(-hc):hc]);
        gc(r, c) = sum(p(:));
    end
end